package jcatest.inboundudp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;

import javax.resource.spi.ActivationSpec;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkException;
import javax.resource.spi.work.WorkManager;

public class InboundUDPWorker implements Work {
	private MessageEndpointFactory mef;
	private WorkManager wm;
    private InboundUDPActivationSpec iuas;
	private volatile boolean released;
	DatagramSocket dgs;
	public InboundUDPWorker(MessageEndpointFactory mef, WorkManager wm,	ActivationSpec as) {
		this.mef = mef;
		this.wm = wm;
        iuas = (InboundUDPActivationSpec)as;
		released = false;
		try {
			int port = iuas.getPortNumber();
			dgs = new DatagramSocket(port);
            if(iuas.getDebug()) {
                System.out.println("listening on " + port);
            }
		} catch (SocketException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void release() {
		released = true;
	}
	@Override
	public void run() {
		while(!released) {
			try {
				byte[] b = new byte[8192];
				DatagramPacket dgp = new DatagramPacket(b, b.length);
				dgs.receive(dgp);
                if(iuas.getDebug()) {
                    System.out.println("message received (" + dgp.getLength() + " bytes)");
                }
                wm.scheduleWork(new InboundUDPWorker2(mef, iuas, dgs, dgp));
                if(iuas.getDebug()) {
                    System.out.println("handler scheduled");
                }
			} catch (IOException e) {
				e.printStackTrace();
			} catch (WorkException e) {
				e.printStackTrace();
			}
		}
	}
}
