package jcatest.inboundudp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import javax.resource.spi.ActivationSpec;
import javax.resource.spi.UnavailableException;
import javax.resource.spi.endpoint.MessageEndpoint;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;

public class InboundUDPWorker2 implements Work {
	private MessageEndpointFactory mef;
    private InboundUDPActivationSpec iuas;
    private DatagramSocket dgs;
    private DatagramPacket dgp;
	private volatile boolean released;
	public InboundUDPWorker2(MessageEndpointFactory mef, InboundUDPActivationSpec iuas, DatagramSocket dgs, DatagramPacket dgp) {
		this.mef = mef;
	    this.iuas = iuas;
	    this.dgs = dgs;
	    this.dgp = dgp;
		released = false;
	}
	@Override
	public void release() {
		released = true;
	}
	@Override
	public void run() {
        if(iuas.getDebug()) {
            System.out.println("handler started");
        }
		if(!released) {
			try {
				MessageEndpoint me = mef.createEndpoint(null);
				if(iuas.getDebug()) {
					System.out.println("endpoint created");
				}
				InboundUDPMessageListener mdb = (InboundUDPMessageListener) me;
                mdb.setDebug(iuas.getDebug());
                mdb.setTest(iuas.getTest());
                byte[] req = new byte[dgp.getLength()];
                System.arraycopy(dgp.getData(), dgp.getOffset(), req, 0, dgp.getLength()); 
                InboundUDPMessage reqmsg = new InboundUDPMessage(req);
                InboundUDPMessage respmsg = mdb.onMessage(reqmsg);
				byte[] resp = respmsg.getData();
				if(iuas.getDebug()) {
					System.out.println("MDB called");
				}
				DatagramPacket dgp2 = new DatagramPacket(resp, resp.length, dgp.getAddress(), dgp.getPort());
				dgs.send(dgp2);
                if(iuas.getDebug()) {
                    System.out.println("response send (" + dgp2.getLength() + " bytes)");
                }
			} catch (UnavailableException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
        if(iuas.getDebug()) {
            System.out.println("handler done");
        }
	}
}
