package jcatest.outboundtcp;

import javax.resource.ResourceException;
import javax.resource.cci.ConnectionMetaData;
import javax.resource.cci.Interaction;
import javax.resource.cci.LocalTransaction;
import javax.resource.cci.ResultSetInfo;

public class OutboundTCPConnectionImpl implements OutboundTCPConnection {
	private OutboundTCPManagedConnection mgcon;
	private boolean debug;
	public OutboundTCPConnectionImpl(OutboundTCPManagedConnection mgcon, boolean debug) {
		this.mgcon = mgcon;
		this.debug = debug;
	}
	@Override
	public void close() throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPConnectionImpl close");
		}
		mgcon.deallocate();
	}
	@Override
	public Interaction createInteraction() throws ResourceException {
		return new OutboundTCPInteraction(this);
	}
	@Override
	public LocalTransaction getLocalTransaction() throws ResourceException {
		throw new ResourceException("Transaction not supported");
	}
	@Override
	public ConnectionMetaData getMetaData() throws ResourceException {
		throw new ResourceException("MetaData not supported");
	}
	@Override
	public ResultSetInfo getResultSetInfo() throws ResourceException {
		throw new ResourceException("ResultSetInfo not supported");
	}
	@Override
	public byte[] execute(byte[] req) {
		return mgcon.execute(req);
	}
}
