package jcatest.outboundtcp;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionEvent;
import javax.resource.spi.ConnectionEventListener;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;

public class OutboundTCPConnectionManager implements ConnectionManager, ConnectionEventListener {
	@Override
	public OutboundTCPConnection allocateConnection(ManagedConnectionFactory mcf, ConnectionRequestInfo cri) throws ResourceException {
		OutboundTCPManagedConnection mc = (OutboundTCPManagedConnection)mcf.createManagedConnection(null, cri);
		mc.addConnectionEventListener(this);
        OutboundTCPConnection c = mc.getConnection(null, cri);
		return c;
	}
	@Override
	public void connectionClosed(ConnectionEvent ce) {
		OutboundTCPManagedConnection mc = (OutboundTCPManagedConnection)ce.getSource();
		try {
			mc.destroy();
		} catch (ResourceException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void connectionErrorOccurred(ConnectionEvent ce) {
		OutboundTCPManagedConnection mc = (OutboundTCPManagedConnection)ce.getSource();
		try {
			mc.destroy();
		} catch (ResourceException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void localTransactionCommitted(ConnectionEvent ce) {
		throw new RuntimeException("Transaction not supported");
	}
	@Override
	public void localTransactionRolledback(ConnectionEvent ce) {
		throw new RuntimeException("Transaction not supported");
	}
	@Override
	public void localTransactionStarted(ConnectionEvent ce) {
		throw new RuntimeException("Transaction not supported");
	}
}

