package jcatest.outboundtcp;

import javax.resource.ResourceException;
import javax.resource.cci.Connection;
import javax.resource.cci.Interaction;
import javax.resource.cci.InteractionSpec;
import javax.resource.cci.Record;
import javax.resource.cci.ResourceWarning;

public class OutboundTCPInteraction implements Interaction {
	private OutboundTCPConnection con;
	public OutboundTCPInteraction(OutboundTCPConnection con) {
		this.con = con;
	}
	@Override
	public void close() throws ResourceException {
		System.out.println("OutboundTCPInteraction close");
	}
	@Override
	public Record execute(InteractionSpec iactspec, Record input) throws ResourceException {
		OutboundTCPMappedRecord reqrec = (OutboundTCPMappedRecord)input;
		byte[] req = (byte[])reqrec.get("data");
		byte[] resp = con.execute(req);
		OutboundTCPMappedRecord resprec = new OutboundTCPMappedRecord();
		resprec.put("data", resp);
		return resprec;
	}
	@Override
	public boolean execute(InteractionSpec iactspec, Record input, Record output) throws ResourceException {
		OutboundTCPMappedRecord reqrec = (OutboundTCPMappedRecord)input;
		OutboundTCPMappedRecord resprec = (OutboundTCPMappedRecord)output;
		byte[] req = (byte[])reqrec.get("data");
		byte[] resp = con.execute(req);
		resprec.put("data", resp);
		return true;
	}
	@Override
	public Connection getConnection() {
		return con;
	}
	@Override
	public void clearWarnings() throws ResourceException {
		throw new ResourceException("warnings unsupported");
	}
	@Override
	public ResourceWarning getWarnings() throws ResourceException {
		throw new ResourceException("warnings unsupported");
	}
}
