package jcatest.outboundtcp;

import java.io.PrintWriter;
import java.util.Set;

import javax.resource.ResourceException;
import javax.resource.cci.ConnectionFactory;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;
import javax.security.auth.Subject;

public class OutboundTCPManagedConnectionFactory implements ManagedConnectionFactory {
	private String serverName;
	private Integer portNumber;
	private Boolean debug;
	private PrintWriter lw;
	@Override
	public ConnectionFactory createConnectionFactory() throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPManagedConnectionFactory created an OutboundTCPConnectionFactoryImpl without ConnectionManager");
		}
		return new OutboundTCPConnectionFactoryImpl(this, null);
	}
	@Override
	public ConnectionFactory createConnectionFactory(ConnectionManager cm)	throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPManagedConnectionFactory created an OutboundTCPConnectionFactoryImpl with ConnectionManager");
		}
		return new OutboundTCPConnectionFactoryImpl(this, cm);
	}
	@Override
	public ManagedConnection createManagedConnection(Subject sub, ConnectionRequestInfo cri) throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPManagedConnectionFactory created an OutboundTCPManagedConnection");
		}
		return new OutboundTCPManagedConnection(serverName, portNumber, debug);
	}
	@Override
	public PrintWriter getLogWriter() throws ResourceException {
		return lw;
	}
	@Override
	public void setLogWriter(PrintWriter lw) throws ResourceException {
		this.lw = lw;
	}
	@Override
	public ManagedConnection matchManagedConnections(Set set, Subject sub, ConnectionRequestInfo cri) throws ResourceException {
		if(set.isEmpty()) {
			if(debug) {
				System.out.println("match: none");
			}
			return null;
		} else {
			if(debug) {
				System.out.println("match: 1 of " + set.size());
			}
			return (ManagedConnection)set.iterator().next();
		}
	}
	public String getServerName() {
		return serverName;
	}
	public void setServerName(String serverName) {
		this.serverName = serverName;
	}
	public Integer getPortNumber() {
		return portNumber;
	}
	public void setPortNumber(Integer portNumber) {
		this.portNumber = portNumber;
	}
	public Boolean getDebug() {
		return debug;
	}
	public void setDebug(Boolean debug) {
		this.debug = debug;
	}
}
